function objHasProps(obj){
    var i = 0;
    for(var key in obj){
        ++i;
    }
    return i;
}

var app = {
	devices:{},
	btactive:null,
	btpermission:null,
	lcenabled:null,
	scanning:null,
	enableTries:0,
	connectionLoop:false,
	language:'en',
	isFake:false,
	deviceValuesChanged:true,
	fakeInit:false,
    initialize: function() {
        this.bindEvents();
		if(app.isFake){
			oDataExamples.init();
			ui.renderDevices();
		}		
    },
    bindEvents: function() {
        document.addEventListener('deviceready', app.onDeviceReady, false);        
    },
    checkLang:function(){
		console.log('app.onDeviceReady');
        if(typeof(navigator.globalization) != 'undefined'){
			navigator.globalization.getPreferredLanguage(
				function(lang){
					if(lang.value.length > 2){
						if(lang.value.substring(0,2).toLowerCase() == 'de'){
							$('body').removeClass('english').addClass('german');
							app.language = 'de';
							$('#exportemail').val('E-Mail Adresse');
					    }
					    else{
							$('body').removeClass('german').addClass('english');
							app.language = 'en';
							$('#exportemail').val('email address');
						}
					}
				},
				function(){
					;
				}
			);
		}
	},
    onDeviceReady: function() {
		//$('#debug').html('');
		
		console.log('app.onDeviceReady');
		document.addEventListener("pause", app.pause, false);
		document.addEventListener("resume", app.resume, false);		
		app.checkLang();
        Camera.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
        Camera.correctOrientation = true;
		app.btInit();		
    },
    pause:function(){
		//$('#debug').append('<p>PAUSE</p>');
		console.log('app.pause');
		app.stopScan();
		clearTimeout(app.checkTimer);
		clearTimeout(app.scanTimer);
		clearTimeout(ui.updateDVTimer);
		app.connectionLoop=false;
		for(var key in app.devices){
			//var paramsObj = {"address": app.devices[key].address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:app.devices[key].address});
			/*
			if(app.devices[key].status == 'subscribedResult'){
				bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
			}
			if(app.devices[key].status != 'out of reach'){
				bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:app.devices[key].address});
			}
			*/
		}
		/*
		$.ajax({
			beforeSend: function(xhrObj){
					//xhrObj.setRequestHeader("Content-Type","text");
			},
			type: "POST",
			url: 'http://www.webentwicklung-dortmund.de/bgdebug/index.php',
			data://$('#debug').html(),
			success:function(data){
				console.log(data);

			},
			error:function(xhr, textStatus){

			},
			fail:function( jqXHR, textStatus, errorThrown ) {

			}
		});
		*/
	},
    resume:function(){
		//$('#debug').append('<p>WEITER</p>');
		console.log('app.resume');
		app.checkLang();
		app.btInit();
		ui.updateDVTimer = ui.updateDevicesView(true);
	},	
    btInit:function(){
		console.log('app.btInit');
		$('#bt-activate .frame').html('');
		var oldDevices = JSON.parse(localStorage.getItem("devices"));
		if(objHasProps(storedDevices)){
			localStorage.removeItem("devices");
		}
		
		var storedDevices = JSON.parse(localStorage.getItem("devices12"));
		if(objHasProps(storedDevices)){
			app.devices = storedDevices;
		}

		for(var key in app.devices){
			app.devices[key].status = 'out of reach';
			if(typeof(app.devices[key].voltType) == 'undefined'){
				app.devices[key].voltType = '?';
			}
			app.devices[key].time = Date.now();
		}
		app.deviceValuesChanged = true;
		if(typeof(bluetoothle) == 'undefined'){
			
		}
		else{
			bluetoothle.isInitialized(app.isInitialized);
		}
		ui.renderDevices();
	},
	isInitialized:function(params){
		//$('#debug').append('<p>INITIALISIERE</p>');
		console.log('app.isInitialized');
		if(params.isInitialized === true){
			app.btactive = 'initialized';
			for(var key in app.devices){
				app.devices[key].status = 'out of reach';
				if(typeof(app.devices[key].voltType) == 'undefined'){
					app.devices[key].voltType = '?';
				}

				var paramsObj = {"address": app.devices[key].address,"service":"1814", "characteristic":"2a53"};
				bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
				bluetoothle.close(app.closeSuccess, app.closeError, {address:app.devices[key].address});

				//bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
			}
			app.deviceValuesChanged = true;
			app.checkPermissions();
		}
		else{
			bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
		}		
	},
	initializeSuccess:function(params){
		//$('#debug').append('<p>INITIALISIERUNG ERFOLGREICH</p>');
		console.log('app.initializeSuccess');
		if(params.status == "enabled"){
			/*
			for(var key in app.devices){
				app.devices[key].status = 'out of reach';
				if(typeof(app.devices[key].voltType) == 'undefined'){
					app.devices[key].voltType = '?';
				}
				var paramsObj = {"address": app.devices[key].address,"service":"1814", "characteristic":"2a53"};
				bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
				bluetoothle.close(app.closeSuccess, app.closeError, {address:app.devices[key].address});
			}
			*/
			app.deviceValuesChanged = true;
			app.btactive = 'initialized';
			app.checkPermissions();
		}
		else{
			app.btactive = 'disabled';
			ui.showBTEnable();
		}
	},
	initializeError:function(params){
		//$('#debug').append('<p>INITIALISIERUNG FEHLER</p>');
		console.log('app.initializeError');
		app.btactive = 'initialize error';
	},
	enable:function(){
		console.log('app.enable');
		if( app.enableTries < 5 ){
			bluetoothle.enable(
				function(params){
					ui.showDevices();
					app.checkPermissions();
				},function(params){
					if(params.error == 'disable'){
						$('#bt-activate .frame').append('<p><p><span class="english">success</span><span class="german">erfolgreich</span></p>');
						ui.showDevices();
						app.enableTries = 5;
						bluetoothle.initialize(app.initializeSuccess, app.initializeError, {request:true});
					}
					app.btactive = 'disabled';
					$('#bt-activate .frame').append('<p><p>&nbsp;</p><p><span class="english">failed</span><span class="german">fehlgeschlagen</span></p><p>&nbsp;</p><p><span class="english">'+(5-app.enableTries)+' tries follow</span><span class="german">noch '+(5-app.enableTries)+' Versuche folgen</span></p>');
			});
			app.enableTries ++;			
			setTimeout(app.enable, 5000);			
		}
		else{
			$('#bt-activate').append('<p><p>&nbsp;</p><p><span class="english">Cannot activate bluetooth.</span><span class="german">Kann Bluetooth nicht aktivieren.</span></p><p>&nbsp;</p><p><span class="english">'+(5-app.enableTries)+' tries follow</span><span class="german">noch '+(5-app.enableTries)+' Versuche folgen</span></p>');			
		}
	},
	checkPermissions:function(){
		//$('#debug').append('<p>PRÜFE BLUETOOTH BERECHTIGUNG</p>');	
		console.log('app.hasPermissionSuccess');
		bluetoothle.hasPermission(app.hasPermissionSuccess);
	},
	hasPermissionSuccess:function(params){
		//$('#debug').append('<p>PRÜFUNG BLUETOOTH ERFOLGREICH</p>');
		console.log('app.hasPermissionSuccess');
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			bluetoothle.isEnabled(app.isEnabled);			
			//$('#debug').append('<p>App hat Bluetoothrechte</p>');
		}
		else{
			bluetoothle.requestPermission(app.requestPermissionSuccess, app.requestPermissionError);	
			//$('#debug').append('<p>App hat keine Bluetoothrechte</p>');
		}
	},
	isEnabled:function(params){
		//$('#debug').append('<p>PRÜFE OB BLUETOOTH AKTIV</p>');
		console.log('app.isEnabled');
		if(params.isEnabled){	
			//$('#debug').append('<p>BLUETOOTH IST AKTIV</p>');
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
		}
		else{			
			//$('#debug').append('<p>BLUETOOTH IST DEAKTIVIERT</p>');
			ui.showBTEnable();
		}
	},
	enableSuccess:function(params){
		//$('#debug').append('<p>BLUETOOTH AKTIVIERUNG ERFOLGREICH</p>');
		ui.showDevices();
		bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
	},
	enableError:function(params){
		//$('#debug').append('<p>BLUETOOTH AKTIVIERUNG FEHLER</p>');
		console.log('app.enableError');
	},
	requestPermissionSuccess:function(params){
		//$('#debug').append('<p>BLUETOOTH BERECHTIGUNG ERFLOGREICH ANGEFORDERT</p>');
		console.log('app.requestPermissionSuccess');
		if(params.hasPermission){
			app.btpermission = 'has permissions';
			bluetoothle.isLocationEnabled(app.isLocationEnabledSuccess, app.isLocationEnabledError);
		}
		else{
			app.startScan();
		}
	},
    isLocationEnabledSuccess: function(params) {
		//$('#debug').append('<p>PRÜFE OB STANDORTE AKTIV ERFOLGREICH</p>');
		console.log('app.isLocationEnabledSuccess');		
		if(params.isLocationEnabled == false && parseInt(device.version) >= 6){			
			//$('#debug').append('<p>Standorte sind nicht aktiviert</p>');
			$('#devices').hide();
			$('#lo-activate').show();
			return;
		}
		//$('#debug').append('<p>Standorte sind aktiviert');
		app.lcenabled = 'enabled';
        app.startScan();
    },
    isLocationEnabledError: function(params) {
		//$('#debug').append('<p>PRÜFE OB STANDORTE AKTIV FEHLER</p>');
		console.log('app.isLocationEnabledError');
		app.lcenabled = 'disabled';
        bluetoothle.requestLocation(app.requestLocationSuccess, app.requestLocationError);
    },
    requestLocationSuccess: function(params) {
		//$('#debug').append('<p>STANDORTE BERECHTIGUNG ERFLOGREICH ANGEFORDERT</p>');
		console.log('app.requestLocationSuccess');
		app.lcenabled = 'enabled';
        app.startScan();
    },
    requestLocationError: function(params) {
		//$('#debug').append('<p>STANDORTE BERECHTIGUNG ERFLOGREICH FEHLER</p>');
		console.log('app.requestLocationError');
		app.lcenabled = 'disabled';
		app.startScan();
    },
    startScan: function(){
		//$('#debug').append('<p>STARTE SCAN');
		console.log('app.startScan');
		$('#scanicon').addClass('rotating');
		if(app.scanning)return;
		if(app.isFake){
			oDataExamples.init();
		}
		for(var key in app.devices){
			if(app.devices[key].status != 'subscribedResult'){
				app.devices[key].status = 'out of reach';
				app.devices[key].working = false;
			}
		}
        
        bluetoothle.retrieveConnected(app.retrieveConnectedSuccess,app.retrieveConnectedError,{'services':['1814']});
        
		app.deviceValuesChanged = true;
		if(typeof(bluetoothle) == 'undefined'){
			app.fakeInit = false;
			setTimeout(function(){$('#scanicon').removeClass('rotating');}, 5000);
		}
		else{
			bluetoothle.startScan(app.scanSuccess, app.startScanError, {
			  "services": [
                "1814"
			  ],
			  "allowDuplicates": true,
			  "scanMode": bluetoothle.SCAN_MODE_LOW_LATENCY,
			  "matchMode": bluetoothle.MATCH_MODE_AGGRESSIVE,
			  "matchNum": bluetoothle.MATCH_NUM_MAX_ADVERTISEMENT,
			  "callbackType": bluetoothle.CALLBACK_TYPE_ALL_MATCHES,
			});
		}
    },
    retrieveConnectedSuccess: function(params){
		//$('#debug').append('<p>ALTE VERBINDUNGEN WIEDER HERSTELLEN ERFOLGREICH</p>');
        console.log('app.retrieveConnectedSuccess');

        //$('#debug').append(params.length+' alte Verdingungen gefunden');
        for(var t = 0; t < params.length; t++){
            if( typeof(app.devices[params[t].address.replace(/:/g, "_")]) == 'object' ){
                app.devices[params[t].address.replace(/:/g, "_")].status = 'found';
                app.devices[params[t].address.replace(/:/g, "_")].time = Date.now();
                app.deviceValuesChanged = true;
            }
            else{
                app.devices[params[t].address.replace(/:/g, "_")] = {address:params[t].address,name:params[t].address,scans:[],status:'found',time:Date.now(),working:false,voltType:'?',volt:'?',imageURI:'img/cardummy.jpg',htmlElements:{}};
                ui.addDevice(params[t].address.replace(/:/g, "_"), app.devices[params[t].address.replace(/:/g, "_")]);
            }
        }
    },
    startScanError: function(params) {
		//$('#debug').append('<p>FEHLER BEI SCAN</p>');
		console.log('app.startScanError');
		$('#scanicon').removeClass('rotating');
		app.scanning = 'error';
    },
    scanSuccess: function(params) {

		console.log('app.scanSuccess');
		if(params.status == 'scanStarted' ){
			app.scanning = 'scanning';
			app.scanTimer = setTimeout(app.stopScan, 5000);
		}
		if(params.status == 'error' ){
            if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
                app.devices[params.address.replace(/:/g, "_")].status = params.status;
                app.devices[params.address.replace(/:/g, "_")].time = Date.now();
                app.scanning = false;
                app.deviceValuesChanged = true;
            }
		}
		if(params.status == 'scanResult' && params.name == 'BLE-VoltageCheck'){
			
			//$('#debug').append('<p>SENDER GEFUNDEN: '+params.address+'</p>');
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = 'found';				
				app.devices[params.address.replace(/:/g, "_")].time = Date.now();
				if(typeof(app.devices[params.address.replace(/:/g, "_")].imageURI) == 'undefined'){
					app.devices[params.address.replace(/:/g, "_")].imageURI = 'img/cardummy.jpg';
				}
			}
			else{
				
				var countDevices = 0;
				for(var key in app.devices){
					countDevices++;
				}

				if( countDevices <= 9 ){
					app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:params.address,scans:[],status:'found',time:Date.now(),working:false,voltType:'?',volt:'?',imageURI:'img/cardummy.jpg',htmlElements:{}};
					ui.addDevice(params.address.replace(/:/g, "_"), app.devices[params.address.replace(/:/g, "_")]);
					var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
					/*
					bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
					bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
					*/
				}
			}
			app.deviceValuesChanged = true;
		}
    },
    getDevices:function(){
		console.log('app.getDevices');
		if(app.isFake == false){
			
		}
		else{
			if( app.fakeInit == false ){
				app.devices = oDataExamples.getData();			
			}
		}
		return app.devices;
	},
	deleteDevice:function(address){
		console.log('app.deleteDevice');
		ui.activeDevice = 0;
		var paramsObj = {"address": address,"service":"1814", "characteristic":"2a53"};
		if(typeof(bluetoothle) == 'undefined'){
		}
		else{
			bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);				
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:address});
		}
		delete(app.devices[address.replace(/:/g, "_")]);
		if(app.isFake){
			oDataExamples.deleteDevice(address.replace(/:/g, "_"));
		}
	},
    connect:function(address){
		
		//$('#debug').append('<p>VERBINDE MIT: '+address);
		console.log('app.connect');
		
		bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": address});
	},
    isConnectedSuccess:function(params){
		
		console.log('app.isConnectedSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			return;
		}
		if(params.isConnected === true){
			//$('#debug').append('<p>SENDER IST VERBUNDEN: '+params.address+'</p>');
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = 'connected';
				app.devices[params.address.replace(/:/g, "_")].time = Date.now();
				app.deviceValuesChanged = true;
			}
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
		else{
			//$('#debug').append('<p>SENDER IST NICHT VERBUNDEN: '+params.address+'</p>');
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = 'closed';
				app.devices[params.address.replace(/:/g, "_")].time = Date.now();
				app.deviceValuesChanged = true;
			}
			bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
		}
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].working = true;
		}
	},
    isConnectedError:function(params){		
		//$('#debug').append('<p>PRÜFEN DER VERBINDUNG : '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('app.isConnectedError');
		console.log(params);
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			return;
		}
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].working = true;
		}
		if(params.message == 'Never connected to device'){
			//$('#debug').append('<p>VERSUCHE zu VERBINDEN :</p>');
			bluetoothle.connect(app.connectSuccess, app.connectError, {"address": params.address});
		}
		else{
			app.bConnecting = false;
		}
	},
    connectSuccess:function(params){
		console.log('app.connectSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
            bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		//$('#debug').append('<p>CONNECT SUCCESS: '+params.address+'</p>');
		//$('#debug').append('<p>CONNECT SUCCESS: '+params.status+'</p>');
		if(params.status == 'connected'){
			//$('#debug').append('<p>VERBINDUNG AUFGEBAUT ZU: '+params.address+'</p>');
			var paramsObj = {"address": params.address};
			
            bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
		}
		else if(params.status == 'disconnected'){
			//$('#debug').append('<p>VERBINDUNG GETRENNT MIT: '+params.address+'</p>');
		
			if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
				app.devices[params.address.replace(/:/g, "_")].status = 'closed';
				app.devices[params.address.replace(/:/g, "_")].working = true;
				app.deviceValuesChanged = true;
			}
		}
		else{
			app.bConnecting = false;
		}
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = params.status;
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
			app.devices[params.address.replace(/:/g, "_")].working = true;
			app.deviceValuesChanged = true;
		}
	},
    connectError:function(params){
		//$('#debug').append('<p>VERBINDUNG FEHLGESCHLAGEN: '+params.address+'</p>');
		//$('#debug').append(params.message);

		console.log('app.connectError');
		console.log(params);
        if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined" ){
        }
        else{
			/*
            app.devices[params.address.replace(/:/g, "_")].status = 'error';
            app.devices[params.address.replace(/:/g, "_")].working = false;
            app.deviceValuesChanged = true;
            */
        }
        //bluetoothle.reconnect(app.reconnectSuccess, app.reconnectError, {"address": params.address});
        app.devices[params.address.replace(/:/g, "_")].working = true;
        
		if(params.message == 'Connection failed'){
			//$('#debug').append('<p>VERSUCHE ERNEUT ZU VERBINDEN</p>');
			setTimeout(function(){
				bluetoothle.reconnect(app.reconnectSuccess, app.reconnectError, {"address": params.address});
			}, 500);
		}
		else if(params.message == 'Device previously connected, reconnect or close for new device'){
			//$('#debug').append('<p>VERSUCHE ERNEUT ZU VERBINDEN</p>');
			setTimeout(function(){
				bluetoothle.reconnect(app.reconnectSuccess, app.reconnectError, {"address": params.address});
			}, 500);
		}
		//Wahrscheinlich unnötig
		else{
            var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
            bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
        }
        //bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
        //bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},
    reconnectSuccess:function(params){
		//$('#debug').append('<p>ERFOLGREICH WIEDER VERBUNDEN MIT: '+params.address+'</p>');
		console.log('app.reconnectSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
            bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		var paramsObj = {"address": params.address};
		app.devices[params.address.replace(/:/g, "_")].working = true;
		bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
	},
    reconnectError:function(params){

		//$('#debug').append('<p>FEHLER BEIM WIEDERVERBINDEN: '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('app.reconnectError');
		console.log(params);
		if(params.message == 'Device isn\'t disconnected'){
			var paramsObj = {"address": params.address};
			app.devices[params.address.replace(/:/g, "_")].working = true;
			bluetoothle.isDiscovered(app.isDiscoveredSuccess, app.isDiscoveredError, paramsObj);
		}
		else{
			bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
		}
		//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},
    stopScan:function(params){
		//$('#debug').append('<p>SCAN BEENDET</p>');
		console.log('app.stopScan');
		
		$('#scanicon').removeClass('rotating');
		bluetoothle.stopScan(app.stopScanSuccess, app.stopScanError);
		app.scanning = false;
		//$('#debug').append('<p>connectionLoop</p>');
		if(app.connectionLoop == false){
			app.checkConnection();
		}
	},
    stopScanSuccess:function(params){
		console.log('app.stopScanSuccess');
	},
    stopScanError:function(params){
	},
    closeSuccess:function(params){
		app.bConnecting = false;
		//$('#debug').append('<p>ERFOLGREICH VERBINDUNG GESCHLOSSEN: '+params.address+'</p>');
		console.log('app.closeSuccess');
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			app.devices[params.address.replace(/:/g, "_")].working = false;
			app.deviceValuesChanged = true;
		}		
	},
    closeError:function(params){
		app.bConnecting = false;
		//$('#debug').append('<p>FEHLER BEIM VERBINDUNG SCHLIESSEN: '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('app.closeError');
		console.log(params);
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].working = false;
		}
	},
    disconnectSuccess:function(params){
		
		//$('#debug').append('<p>ERFOLGREICH VERBINDUNG GETRENNT: '+params.address+'</p>');
        console.log('app.disconnectSuccess');
		bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = 'closed';
			app.devices[params.address.replace(/:/g, "_")].working = true;
			app.deviceValuesChanged = true;
		}		
	},
    disconnectError:function(params){
		
		//$('#debug').append('<p>FEHLER BEM VERBINDUNG TRENNEN: '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('disconnectError');
        console.log(params);
		if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].working = true;
		}
        bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},   
	isDiscoveredSuccess:function(params){
		//$('#debug').append('<p>ERFOLGREICH GEPRÜFT OB SERVICE GEFUNDEN: '+params.address+'</p>');
		console.log('app.isDiscoveredSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
        
            bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		app.devices[params.address.replace(/:/g, "_")].working = true;
		if(params.isDiscovered === true){
			//$('#debug').append('<p>Service wurde schon gefunden');
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
		}
		else{
			//$('#debug').append('<p>Service wurde noch nicht gefunden');
			bluetoothle.discover(app.discoverSuccess, app.discoverError, params);
		}
	},
	isDiscoveredError:function(params){
		//$('#debug').append('<p>PRÜFUNG OB SERVICE GEFUNDEN FEHLER: '+params.address+'</p>');
		//$('#debug').append('<p>'+params.message+'</p>');
		console.log('app.isDiscoveredError');
		console.log(params);
		if( params.message == 'Device isn\'t connected' ){
			bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": params.address});
		}
		else if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
			app.devices[params.address.replace(/:/g, "_")].status = 'error';		
			app.devices[params.address.replace(/:/g, "_")].working = true;
			app.deviceValuesChanged = true;
            var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
            bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);               
		}
	},
	discoverSuccess:function(params){		
		//$('#debug').append('<p>ERFOLGREICH SERVICE GEFUNDEN: '+params.address+'</p>');
		//$('#debug').append('<p>Status ist: '+params.status+'</p>');
		console.log('app.discoverSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
            var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
            bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		if (params.status == "discovered"){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.subscribe(app.subscribeSuccess, app.subscribeError, paramsObj);
			app.devices[params.address.replace(/:/g, "_")].status = 'discovered';
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
			app.deviceValuesChanged = true;
		}		
		app.devices[params.address.replace(/:/g, "_")].working = true;
	},
	discoverError:function(params){
		 
		//$('#debug').append('<p>SERVICE FINDEN FEHLER: '+params.address+'</p>');
		console.log('app.discoverError');
		console.log(params);
        if( typeof(app.devices[params.address.replace(/:/g, "_")]) == 'object' ){
            app.devices[params.address.replace(/:/g, "_")].status = 'error';
            app.devices[params.address.replace(/:/g, "_")].working = false;
            app.deviceValuesChanged = true;
        }
        var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
        bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);
	},
	subscribeSuccess:function(params){
		//console.log('app.subscribeSuccess');
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
			var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};
			bluetoothle.unsubscribe(app.unsubscribeSuccess, app.unsubscribeError, paramsObj);		
			bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}	
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) !== 'object'){
			app.devices[params.address.replace(/:/g, "_")] = {address:params.address,name:'',scans:[],status:params.status,time:Date.now()};
			app.deviceValuesChanged = true;
		}
		else{
			app.devices[params.address.replace(/:/g, "_")].status = params.status;
			app.devices[params.address.replace(/:/g, "_")].time = Date.now();
		}

		if (params.status == "subscribedResult"){
			if(app.devices[params.address.replace(/:/g, "_")].working){			
				app.devices[params.address.replace(/:/g, "_")].working = false;	
				//$('#debug').append('<p>SERVICE ABONIERT: '+params.address+'.<br /> Empfange jetzt Daten.</p>');
			}
			var bytes = bluetoothle.encodedStringToBytes(params.value);
			if (bytes.length == 0){
				return;
			}
			var flag = bytes[0];
			var hr;
			if ((flag & 0x01) == 1){
				hr = ( (((bytes[2] & 0xff) << 8) | (bytes[1] & 0xff)) );
			}
			else{
				hr = ( (((bytes[2] & 0xff) << 8) | (bytes[1] & 0xff)) );
			}
			if(app.devices[params.address.replace(/:/g, "_")].voltType == "?"){
				if(hr < 9000 ){
					  app.devices[params.address.replace(/:/g, "_")].voltType = 0;
				}
				else if(hr >= 9000 && hr < 18000){
					 app.devices[params.address.replace(/:/g, "_")].voltType = 1;
				}
				else if(hr >= 18000 ){
					  app.devices[params.address.replace(/:/g, "_")].voltType = 2;
				}
			}
			var hr2 = hr/1000;

			if(app.devices[params.address.replace(/:/g, "_")].volt != hr2){
				app.deviceValuesChanged = true;
				app.devices[params.address.replace(/:/g, "_")].volt = hr2;
			}			
			
			if(app.devices[params.address.replace(/:/g, "_")].scans.length == 0){
				app.devices[params.address.replace(/:/g, "_")].scans[0] = [Date.now(),hr2];
			}else if(
				app.devices[params.address.replace(/:/g, "_")].scans[app.devices[params.address.replace(/:/g, "_")].scans.length-1][0] + 3600000*24 < Date.now()
			||	(
				app.devices[params.address.replace(/:/g, "_")].scans[app.devices[params.address.replace(/:/g, "_")].scans.length-1][0] + 3600000 < Date.now()
			&&	(
				app.devices[params.address.replace(/:/g, "_")].scans[app.devices[params.address.replace(/:/g, "_")].scans.length-1][1] > hr2+0.3
			||	app.devices[params.address.replace(/:/g, "_")].scans[app.devices[params.address.replace(/:/g, "_")].scans.length-1][1] < hr2-0.3
				)
			)
			){
				app.devices[params.address.replace(/:/g, "_")].scans[app.devices[params.address.replace(/:/g, "_")].scans.length] = [Date.now(),hr2];
			}
		}
	},
	subscribeError:function(params){
		//$('#debug').append('<p>SERVICE ABONIEREN FEHLER: '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('app.subscribeError');
		console.log(params);
		var paramsObj = {"address": params.address,"service":"1814", "characteristic":"2a53"};	
	},
	unsubscribeSuccess:function(params){
		//$('#debug').append('<p>ERFOLGREICH SERVICE ABBESTELLT FEHLER: '+params.address+'</p>');
		console.log('app.unsubscribeSuccess');	
        if(typeof(app.devices[params.address.replace(/:/g, "_")]) != "undefined"){
            app.devices[params.address.replace(/:/g, "_")].working = true;
        }
        
        bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
        //bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
	},
	unsubscribeError:function(params){
		//$('#debug').append('<p>SERVICE ABBESTELLEN FEHLER: '+params.address+'</p>');
		//$('#debug').append(params.message);
		console.log('app.unsubscribeError');
		console.log(params);
		if(typeof(app.devices[params.address.replace(/:/g, "_")]) == "undefined"){
            bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
			//bluetoothle.close(app.closeSuccess, app.closeError, {address:params.address});
			return;
		}
		app.devices[params.address.replace(/:/g, "_")].working = true;
        bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:params.address});
		
	},
	checkConnection:function(){
		//$('#debug').append('<p>PRÜFE VERBINDUNGEN</p>');
		console.log('app.checkConnection');

		if(app.scanning){
			app.checkTimer = setTimeout(app.checkConnection, 3000);
			return;			
		}
		app.connectionLoop = true;
		for(var key in app.devices){
			if(app.devices[key].working){
				//$('#debug').append('<p>VERBINDUNGAUFBAU NOCH IM GANGE</p>');
				if(  ( (Date.now() - app.devices[key].time ) > 10000  && app.devices[key].status == 'found' ) || ( Date.now() -  app.devices[key].time ) > 30000){
					//$('#debug').append('<p>VERBINDUNGAUFBAU DAUERT ZU LANGE. ABBRUCH</p>');
					app.devices[key].status = 'abbort';
					app.devices[key].time = Date.now();
					bluetoothle.disconnect(app.disconnectSuccess, app.disconnectError, {address:app.devices[key].address});
				}
				app.checkTimer = setTimeout(app.checkConnection, 3000);
				return;
			}
		}
		
		for(var key in app.devices){	
			console.log(app.devices[key].working);
			//$('#debug').append('<p>Sender: '+app.devices[key].address+'.Status:'+app.devices[key].status+', Arbeitet:'+app.devices[key].working+'</p>');
			if(app.devices[key].status == 'subscribedResult' || app.devices[key].status == 'out of reach'){

			}
			else if( app.devices[key].status == 'found' /*|| ( ( Date.now() - app.devices[key].time ) > 5000  && app.devices[key].status != 'closed'*/ && app.devices[key].working == false  ){
				//$('#debug').append('<p>Versuche mit '+app.devices[key].address+' Verbindung aufzubauen.Status'+app.devices[key].status+', Arbeitet:'+app.devices[key].working+'</p>');
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}
			else if( ( ( Date.now() - app.devices[key].time ) > 10000  && app.devices[key].working == false && app.devices[key].status != 'closed') ){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}	
			else if( ( ( Date.now() - app.devices[key].time ) > 60000  ) ){
				bluetoothle.isConnected(app.isConnectedSuccess, app.isConnectedError, {"address": app.devices[key].address});
				break;
			}	
		}		
		app.checkTimer = setTimeout(app.checkConnection, 3000);
	},			
    error: function(text) {
        //$('#debug').append('<p>App ended on error'+text+'</p>');
    }
};

app.initialize();

window.onerror = function(message, url, lineNumber) {
	$('#text').append("Error: "+message+" in "+url+" at line "+lineNumber);
}
